package cn.com.infosec.asn1.x509.qualified;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import java.math.BigInteger;
import java.util.Enumeration;

public class MonetaryValue extends ASN1Encodable {
   Iso4217CurrencyCode currency;
   DERInteger amount;
   DERInteger exponent;

   public static MonetaryValue getInstance(Object obj) {
      if (obj != null && !(obj instanceof MonetaryValue)) {
         if (obj instanceof ASN1Sequence) {
            return new MonetaryValue(ASN1Sequence.getInstance(obj));
         } else {
            throw new IllegalArgumentException("unknown object in getInstance");
         }
      } else {
         return (MonetaryValue)obj;
      }
   }

   public MonetaryValue(ASN1Sequence seq) {
      MonetaryValue var10000 = this;
      MonetaryValue var10001 = this;
      super();
      Enumeration var2;
      this.currency = Iso4217CurrencyCode.getInstance((var2 = seq.getObjects()).nextElement());
      var10001.amount = DERInteger.getInstance(var2.nextElement());
      var10000.exponent = DERInteger.getInstance(var2.nextElement());
   }

   public MonetaryValue(Iso4217CurrencyCode currency, int amount, int exponent) {
      MonetaryValue var10000 = this;
      MonetaryValue var10001 = this;
      super();
      this.currency = currency;
      DERInteger var4;
      var4 = new DERInteger.<init>(amount);
      var10001.amount = var4;
      var4 = new DERInteger.<init>(exponent);
      var10000.exponent = var4;
   }

   public Iso4217CurrencyCode getCurrency() {
      return this.currency;
   }

   public BigInteger getAmount() {
      return this.amount.getValue();
   }

   public BigInteger getExponent() {
      return this.exponent.getValue();
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.currency);
      var1.add(this.amount);
      var10000.add(this.exponent);
      return new DERSequence(var1);
   }
}
